#include <stdio.h>
#include <stdlib.h>

#define CMDSZ 1024

int excmd(FILE *);


int
main(void)
{
	int c;

	while((c = fgetc(stdin)) != EOF){
		if(c == '%'){
			if((c = fgetc(stdin)) != '%'){
				ungetc(c, stdin);
				fflush(stdout);
				if(excmd(stdin) < 0){
					fprintf(stderr, "gn: err: command too long or missing end percent\n");
					return 1;
				}
				continue;
			}
		}
		fputc(c, stdout);
	}
	return 0;
}

/*For simplicity, commands are restricted to CMDSZ chars.*/
int
excmd(FILE *f)
{
	static char cmd[CMDSZ];
	int i = 0, c;

	while((c = fgetc(f)) != EOF && i < CMDSZ){
		if(c == '%'){
			if((c = fgetc(f)) != '%'){
				ungetc(c, f);
				cmd[i] = '\0';
				system(cmd);
				return 0;
			}
		}
		cmd[i++] = c;
	}
	return i < CMDSZ && c != EOF ? 0 : -1;
}
